/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2013 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 */

/*
 *  åȥܡɤ˴ؤ(LPCXPRESSO-LPC812)
 *
 *  ޥսꡧ
 *  (1) PLLѤʤ USE_SYSTEM_PLL ޥ򥳥ȥȤ(ξᥤ󥯥åIRCȤʤ)
 *  (2) 졼ѤʤϡUSE_EXTERNAL_OSCILLATOR ޥ򥳥ȥȤ
 *  (3) 졼μȿۤʤ OSC_CLOCK ͤѹ
 *  (4) ᥤ󥯥åμȿѹ MAIN_CLOCK ͤѹ
 *      κݡSYSPLLCTRL쥸ͤ TVALUE_SYSCON_SYSPLLCTRL ޥ˻ꤹ
 *      ƥ९åͤꤹ뤿ᡤᥤ󥯥åʬ TVALUE_SYSCON_SYSAHBCLKDIV 
 *      (ƥ९åϾ30MHzȤ¤)
 */

#ifndef TOPPERS_LPCXPRESSO_LPC812_H
#define TOPPERS_LPCXPRESSO_LPC812_H

#include <sil.h>
#include "LPC812M101FDH20.h"

// PLL ѤʻѤʤϥȥȤ롥
// PLLԻѤξ硤åIRCȤʤ(졼ϻѤʤ)
#define USE_SYSTEM_PLL

// 졼ѤʻѤʤϥȥȤ롥åIRCȤʤ
#define USE_EXTERNAL_OSCILLATOR

/*
 *  åϢ
 */
// RC(IRC)åμȿ
#define IRC_CLOCK	(12 * 1000 * 1000)	/* 12MHz */

// 졼åμȿ(IRCȤȤ IRC_CLOCK, XTALѤȤϼºݤͤ˹碌ѹ)
#define OSC_CLOCK	(12 * 1000 * 1000)	/* 12MHz */

// ᥤ󥯥å
#ifdef USE_SYSTEM_PLL
	#define MAIN_CLOCK	(60 * 1000 * 1000)	/* 60MHz */
#else
	#define MAIN_CLOCK	IRC_CLOCK	/* 12MHz */
#endif

/*
 * ƥPLL
 */
#ifdef USE_SYSTEM_PLL
	#ifdef USE_EXTERNAL_OSCILLATOR /* å */
		// ƥPLLΥå
		#define TVALUE_SYSCON_SYSPLLCLKSEL TBITPTN_SYSCON_SYSPLLCLKSEL_SEL_SYSOSC 	// åȤƥƥ४졼
		// ƥ४졼
		#define TVALUE_SYSCON_SYSOSCCTRL	0	// ƥ४졼Хѥʤ(BYPASS=0), ϥå 1-20MHzϰ
	#else /* USE_EXTERNAL_OSCILLATOR */
		// ƥPLLΥå
		#define TVALUE_SYSCON_SYSPLLCLKSEL TBITPTN_SYSCON_SYSPLLCLKSEL_SEL_IRC 	// åȤRC졼
	#endif /* USE_EXTERNAL_OSCILLATOR */

	// PLLܴ浪ʬΥѥ᡼
	// ʲɤǤPLLѥ᡼ExcelȤǻФ
	// http://www.lpcware.com/content/nxpfile/lpc8xx-clock-and-pll-configuration-tool
	// ˤȡϼȿ12MHz60MHzΥᥤ󥯥å硤PSEL=2, MSEL=4
	#define TVALUE_SYSCON_SYSPLLCTRL_MSEL	(0x04)	// MSEL = 4
	#define TVALUE_SYSCON_SYSPLLCTRL	(TBITPTN_SYSCON_SYSPLLCTRL_PSEL_P2 | TVALUE_SYSCON_SYSPLLCTRL_MSEL)
#endif	/* USE_SYSTEM_PLL */

/*
 * ᥤ󥯥å
 */
#ifdef USE_SYSTEM_PLL
	#define TVALUE_SYSCON_MAINCLKSEL	TBITPTN_SYSCON_MAINCLKSEL_SEL_PLLOUT	// ᥤ󥯥åϥƥPLLνϥåȤ
#else
	#define TVALUE_SYSCON_MAINCLKSEL	TBITPTN_SYSCON_MAINCLKSEL_SEL_IRC	// ᥤ󥯥åIRCȤ
#endif

/*
 * ƥ९å
 */
#ifdef USE_SYSTEM_PLL
	#define TVALUE_SYSCON_SYSAHBCLKDIV 2	// ƥ९åϥᥤ󥯥å2ʬ(30MHz)
#else
	#define TVALUE_SYSCON_SYSAHBCLKDIV 1	// ƥ९åϥᥤ󥯥å1ʬ(12MHz)
#endif

#define SYSTEM_CLOCK 	(MAIN_CLOCK/TVALUE_SYSCON_SYSAHBCLKDIV)

// ¾⥸塼ؤΥåON/OFF
#define TVALUE_SYSCON_SYSAHBCLKCTRL	(TBITPTN_SYSCON_SYSAHBCLKCTRL_SWM | TBITPTN_SYSCON_SYSAHBCLKCTRL_IOCON)	// SWM, IOCONΥåON

/*
 * UARTΥå
 */
#define TVALUE_SYSCON_UARTCLKDIV	(1)	// UARTΥåϥᥤ󥯥å1ʬ

// BRG쥸͡"baudrate = (MAIN_CLOCK/UARTCLKDIV) / 16*(BRG+1)" δط褦BRGꤹ롥
#define TVALUE_USART_BRG(baudrate)	(MAIN_CLOCK/TVALUE_SYSCON_UARTCLKDIV/16/(baudrate) - 1)

// Fractional rate generator.
// ܡ졼Ȥɸͤ goal_baudrate
// BRG ͤƳФܡ졼ȡ real_baudrate = (main_clock/UARTCLKDIV) / 16*(BRG+1)
// DIV  UARTFRGDIV(ǡȤꡤ255)
// MULT  UARTFRGMULT(0-255)
// ȤȤδط褦ˡMULTꤷƥܡ졼ȥåĴ
// {(MULT+1)/(DIV+1)} + 1 = real_baudrate / goal_baudrate
// ǽ˷ꤷgoal_baudrate˴ŤBRGͤ׻顤DIV255ȤMULTͤ׻롥
#define TVALUE_SYSCON_UARTFRGDIV	(0xff)
#define TVALUE_SYSCON_UARTFRGMULT(baudrate) \
		((((MAIN_CLOCK / TVALUE_SYSCON_UARTCLKDIV) / 16) * (TVALUE_SYSCON_UARTFRGDIV + 1)) / (baudrate * (TVALUE_USART_BRG(baudrate) + 1))) - (TVALUE_SYSCON_UARTFRGDIV + 1)

// Systick
#define SYSTIC_CLOCK	(SYSTEM_CLOCK)


#ifndef TOPPERS_MACRO_ONLY

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_LPCXPRESSO_LPC812_H */
